

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>ELF notes &mdash; Xen 4.16-unstable documentation</title>
  

  
  
  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  

  

  
        <link rel="index" title="Index"
              href="../../genindex.html"/>
        <link rel="search" title="Search" href="../../search.html"/>
    <link rel="top" title="Xen 4.16-unstable documentation" href="../../index.html"/>
        <link rel="up" title="Hypercall Interfaces - arm64" href="../arm64.html"/>
        <link rel="next" title="Glossary" href="../../glossary.html"/>
        <link rel="prev" title="XEN ELFNOTE FEATURES" href="xen_elfnote_features.html"/> 

  
  <script src="../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

   
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../index.html" class="icon icon-home"> Xen
          

          
          </a>

          
            
            
              <div class="version">
                4.16
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../admin-guide/index.html">Admin Guide</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../guest-guide/index.html">Guest documentation</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../hypervisor-guide/index.html">Hypervisor documentation</a></li>
</ul>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">Hypercall Interfaces</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="../arm64.html">Hypercall Interfaces - arm64</a><ul class="current">
<li class="toctree-l3 current"><a class="reference internal" href="../arm64.html#starting-points">Starting points</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="hypercall_calling_convention.html">Hypercall Calling Convention</a></li>
<li class="toctree-l4"><a class="reference internal" href="supported_hypercalls.html">Supported hypercalls</a></li>
<li class="toctree-l4"><a class="reference internal" href="list_of_hypercalls.html">List of hypercalls</a></li>
<li class="toctree-l4"><a class="reference internal" href="guest_scheduler_operations.html">Guest Scheduler Operations</a></li>
<li class="toctree-l4"><a class="reference internal" href="grant_tables.html">Grant Tables</a></li>
<li class="toctree-l4"><a class="reference internal" href="event_channels.html">Event Channels</a></li>
<li class="toctree-l4"><a class="reference internal" href="xenstore_wire_protocol.html">XenStore wire protocol</a></li>
<li class="toctree-l4"><a class="reference internal" href="start_of_day_shared_data_structure.html">Start-of-day shared data structure</a></li>
<li class="toctree-l4"><a class="reference internal" href="start_of_day_memory_layout.html">Start-of-day memory layout</a></li>
<li class="toctree-l4"><a class="reference internal" href="dom0_console.html">Dom0 console</a></li>
<li class="toctree-l4"><a class="reference internal" href="xen_elfnote_features.html">XEN ELFNOTE FEATURES</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">ELF notes</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#functions">Functions</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#structs">Structs</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#enums-and-sets-of-defines">Enums and sets of #defines</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#typedefs">Typedefs</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#enum-values-and-individual-defines">Enum values and individual #defines</a></li>
</ul>
</li>
</ul>
</li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../glossary.html">Glossary</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Xen</a>
        
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../index.html">Hypercall Interfaces</a> &raquo;</li>
        
          <li><a href="../arm64.html">Hypercall Interfaces - arm64</a> &raquo;</li>
        
      <li>ELF notes</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/hypercall-interfaces/common/elf_notes.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="elf-notes">
<h1>ELF notes<a class="headerlink" href="#elf-notes" title="Permalink to this headline">¶</a></h1>
<dl class="group">
<dt>
<span class="target" id="group__elf__notes"></span><em>group</em> <code class="descname">elf_notes</code></dt>
<dd><p>ELF notes. </p>
<p>The notes should live in a PT_NOTE segment and have “Xen” in the name field.</p>
<p>Numeric types are either 4 or 8 bytes depending on the content of the desc field.</p>
<p>LEGACY indicated the fields in the legacy __xen_guest string which this a note type replaces.</p>
<p>String values (for non-legacy) are NULL terminated ASCII, also known as ASCIZ type. </p>
<div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Defines</p>
<dl class="define">
<dt id="c.XEN_ELFNOTE_INFO">
<span class="target" id="group__elf__notes_1ga86705363b0071bc5f8d6068108281352"></span><code class="descname">XEN_ELFNOTE_INFO</code> 0<a class="headerlink" href="#c.XEN_ELFNOTE_INFO" title="Permalink to this definition">¶</a></dt>
<dd><p>NAME=VALUE pair (string). </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_ENTRY">
<span class="target" id="group__elf__notes_1gaad383e2ddd97eab8140eb9204d0a3a6a"></span><code class="descname">XEN_ELFNOTE_ENTRY</code> 1<a class="headerlink" href="#c.XEN_ELFNOTE_ENTRY" title="Permalink to this definition">¶</a></dt>
<dd><p>The virtual address of the entry point (numeric).</p>
<p>LEGACY: VIRT_ENTRY </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_HYPERCALL_PAGE">
<span class="target" id="group__elf__notes_1ga173b14bc9ea14b2d898244a9848695d7"></span><code class="descname">XEN_ELFNOTE_HYPERCALL_PAGE</code> 2<a class="headerlink" href="#c.XEN_ELFNOTE_HYPERCALL_PAGE" title="Permalink to this definition">¶</a></dt>
<dd><p>The virtual address of the hypercall transfer page (numeric).</p>
<p>LEGACY: HYPERCALL_PAGE. (n.b. legacy value is a physical page number not a virtual address) </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_VIRT_BASE">
<span class="target" id="group__elf__notes_1ga8675534a46ba62bdd5497022f46394ac"></span><code class="descname">XEN_ELFNOTE_VIRT_BASE</code> 3<a class="headerlink" href="#c.XEN_ELFNOTE_VIRT_BASE" title="Permalink to this definition">¶</a></dt>
<dd><p>The virtual address where the kernel image should be mapped (numeric).</p>
<p>Defaults to 0.</p>
<p>LEGACY: VIRT_BASE </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_PADDR_OFFSET">
<span class="target" id="group__elf__notes_1gaadfd95c7bf7ae36fb08bdfb7a51c0545"></span><code class="descname">XEN_ELFNOTE_PADDR_OFFSET</code> 4<a class="headerlink" href="#c.XEN_ELFNOTE_PADDR_OFFSET" title="Permalink to this definition">¶</a></dt>
<dd><p>The offset of the ELF paddr field from the actual required pseudo-physical address (numeric).</p>
<p>This is used to maintain backwards compatibility with older kernels which wrote __PAGE_OFFSET into that field. This field defaults to 0 if not present.</p>
<p>LEGACY: ELF_PADDR_OFFSET. (n.b. legacy default is VIRT_BASE) </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_XEN_VERSION">
<span class="target" id="group__elf__notes_1ga1bd4a94b7425a9bbb558e514a9488417"></span><code class="descname">XEN_ELFNOTE_XEN_VERSION</code> 5<a class="headerlink" href="#c.XEN_ELFNOTE_XEN_VERSION" title="Permalink to this definition">¶</a></dt>
<dd><p>The version of Xen that we work with (string).</p>
<p>LEGACY: XEN_VER </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_GUEST_OS">
<span class="target" id="group__elf__notes_1gab3f1b5db005c16d427a2ac7401109244"></span><code class="descname">XEN_ELFNOTE_GUEST_OS</code> 6<a class="headerlink" href="#c.XEN_ELFNOTE_GUEST_OS" title="Permalink to this definition">¶</a></dt>
<dd><p>The name of the guest operating system (string).</p>
<p>LEGACY: GUEST_OS </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_GUEST_VERSION">
<span class="target" id="group__elf__notes_1gaabbb483870c303d87c5f9e5481b84a24"></span><code class="descname">XEN_ELFNOTE_GUEST_VERSION</code> 7<a class="headerlink" href="#c.XEN_ELFNOTE_GUEST_VERSION" title="Permalink to this definition">¶</a></dt>
<dd><p>The version of the guest operating system (string).</p>
<p>LEGACY: GUEST_VER </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_LOADER">
<span class="target" id="group__elf__notes_1ga3d5ed54b066427817768a9cf8ebc1243"></span><code class="descname">XEN_ELFNOTE_LOADER</code> 8<a class="headerlink" href="#c.XEN_ELFNOTE_LOADER" title="Permalink to this definition">¶</a></dt>
<dd><p>The loader type (string).</p>
<p>LEGACY: LOADER </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_PAE_MODE">
<span class="target" id="group__elf__notes_1ga45759270cf29f5cebc7a635e1c11ec9a"></span><code class="descname">XEN_ELFNOTE_PAE_MODE</code> 9<a class="headerlink" href="#c.XEN_ELFNOTE_PAE_MODE" title="Permalink to this definition">¶</a></dt>
<dd><p>The kernel supports PAE (x86/32 only, string = “yes”, “no” or “bimodal”).</p>
<p>For compatibility with Xen 3.0.3 and earlier the “bimodal” setting may be given as “yes,bimodal” which will cause older Xen to treat this kernel as PAE.</p>
<p>LEGACY: PAE (n.b. The legacy interface included a provision to indicate ‘extended-cr3’ support allowing L3 page tables to be placed above 4G. It is assumed that any kernel new enough to use these ELF notes will include this and therefore “yes” here is equivalent to “yes[entended-cr3]” in the __xen_guest interface. </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_FEATURES">
<span class="target" id="group__elf__notes_1ga1e6d47cfada79e9c5e03444cfe043ddd"></span><code class="descname">XEN_ELFNOTE_FEATURES</code> 10<a class="headerlink" href="#c.XEN_ELFNOTE_FEATURES" title="Permalink to this definition">¶</a></dt>
<dd><p>The features supported/required by this kernel (string).</p>
<p>The string must consist of a list of feature names (as given in features.h, without the “XENFEAT_” prefix) separated by ‘|’ characters. If a feature is required for the kernel to function then the feature name must be preceded by a ‘!’ character.</p>
<p>LEGACY: FEATURES </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_BSD_SYMTAB">
<span class="target" id="group__elf__notes_1gad6f520f7d06da3f4ca94018d143cd35e"></span><code class="descname">XEN_ELFNOTE_BSD_SYMTAB</code> 11<a class="headerlink" href="#c.XEN_ELFNOTE_BSD_SYMTAB" title="Permalink to this definition">¶</a></dt>
<dd><p>The kernel requires the symbol table to be loaded (string = “yes” or “no”) LEGACY: BSD_SYMTAB (n.b. The legacy treated the presence or absence of this string as a boolean flag rather than requiring “yes” or “no”. </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_HV_START_LOW">
<span class="target" id="group__elf__notes_1ga940c66bdc1786fb1e30279bd821a1991"></span><code class="descname">XEN_ELFNOTE_HV_START_LOW</code> 12<a class="headerlink" href="#c.XEN_ELFNOTE_HV_START_LOW" title="Permalink to this definition">¶</a></dt>
<dd><p>The lowest address the hypervisor hole can begin at (numeric).</p>
<p>This must not be set higher than HYPERVISOR_VIRT_START. Its presence also indicates to the hypervisor that the kernel can deal with the hole starting at a higher address. </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_L1_MFN_VALID">
<span class="target" id="group__elf__notes_1gad08e5556fbd9262a5d4f86fd606d4561"></span><code class="descname">XEN_ELFNOTE_L1_MFN_VALID</code> 13<a class="headerlink" href="#c.XEN_ELFNOTE_L1_MFN_VALID" title="Permalink to this definition">¶</a></dt>
<dd><p>List of maddr_t-sized mask/value pairs describing how to recognize (non-present) L1 page table entries carrying valid MFNs (numeric). </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_SUSPEND_CANCEL">
<span class="target" id="group__elf__notes_1ga3327b4b37f72d80c65ad7b8426fee0b0"></span><code class="descname">XEN_ELFNOTE_SUSPEND_CANCEL</code> 14<a class="headerlink" href="#c.XEN_ELFNOTE_SUSPEND_CANCEL" title="Permalink to this definition">¶</a></dt>
<dd><p>Whether or not the guest supports cooperative suspend cancellation. This is a numeric value.</p>
<p>Default is 0 </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_INIT_P2M">
<span class="target" id="group__elf__notes_1ga12688927495f4105a65ee4c71e8f6939"></span><code class="descname">XEN_ELFNOTE_INIT_P2M</code> 15<a class="headerlink" href="#c.XEN_ELFNOTE_INIT_P2M" title="Permalink to this definition">¶</a></dt>
<dd><p>The (non-default) location the initial phys-to-machine map should be placed at by the hypervisor (Dom0) or the tools (DomU). The kernel must be prepared for this mapping to be established using large pages, despite such otherwise not being available to guests. Note that these large pages may be misaligned in PFN space (they’ll obviously be aligned in MFN and virtual address spaces). The kernel must also be able to handle the page table pages used for this mapping not being accessible through the initial mapping. (Only x86-64 supports this at present.) </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_MOD_START_PFN">
<span class="target" id="group__elf__notes_1gaa2ce054d04e9ffe4818b7e42bf0c620f"></span><code class="descname">XEN_ELFNOTE_MOD_START_PFN</code> 16<a class="headerlink" href="#c.XEN_ELFNOTE_MOD_START_PFN" title="Permalink to this definition">¶</a></dt>
<dd><p>Whether or not the guest can deal with being passed an initrd not mapped through its initial page tables. </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_SUPPORTED_FEATURES">
<span class="target" id="group__elf__notes_1ga82c663f99504a547606079094a4ff04a"></span><code class="descname">XEN_ELFNOTE_SUPPORTED_FEATURES</code> 17<a class="headerlink" href="#c.XEN_ELFNOTE_SUPPORTED_FEATURES" title="Permalink to this definition">¶</a></dt>
<dd><p>The features supported by this kernel (numeric).</p>
<p>Other than XEN_ELFNOTE_FEATURES on pre-4.2 Xen, this note allows a kernel to specify support for features that older hypervisors don’t know about. The set of features 4.2 and newer hypervisors will consider supported by the kernel is the combination of the sets specified through this and the string note.</p>
<p>LEGACY: FEATURES </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_PHYS32_ENTRY">
<span class="target" id="group__elf__notes_1ga8bd6e4bf9eba630544a34f1ab2e50db7"></span><code class="descname">XEN_ELFNOTE_PHYS32_ENTRY</code> 18<a class="headerlink" href="#c.XEN_ELFNOTE_PHYS32_ENTRY" title="Permalink to this definition">¶</a></dt>
<dd><p>Physical entry point into the kernel.</p>
<p>32bit entry point into the kernel. When requested to launch the guest kernel in a HVM container, Xen will use this entry point to launch the guest in 32bit protected mode with paging disabled. Ignored otherwise. </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_MAX">
<span class="target" id="group__elf__notes_1gaedd46dabc09e8a7fee21abd2d9337039"></span><code class="descname">XEN_ELFNOTE_MAX</code> XEN_ELFNOTE_PHYS32_ENTRY<a class="headerlink" href="#c.XEN_ELFNOTE_MAX" title="Permalink to this definition">¶</a></dt>
<dd><p>The number of the highest elfnote defined. </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_CRASH_INFO">
<span class="target" id="group__elf__notes_1ga574c1a97e819607ad918eb3e6097c0de"></span><code class="descname">XEN_ELFNOTE_CRASH_INFO</code> 0x1000001<a class="headerlink" href="#c.XEN_ELFNOTE_CRASH_INFO" title="Permalink to this definition">¶</a></dt>
<dd><p>System information exported through crash notes.</p>
<p>The kexec / kdump code will create one XEN_ELFNOTE_CRASH_INFO note in case of a system crash. This note will contain various information about the system, see xen/include/xen/elfcore.h. </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_CRASH_REGS">
<span class="target" id="group__elf__notes_1ga6c34f2fc482a16dca3dd0e3bd4c30e27"></span><code class="descname">XEN_ELFNOTE_CRASH_REGS</code> 0x1000002<a class="headerlink" href="#c.XEN_ELFNOTE_CRASH_REGS" title="Permalink to this definition">¶</a></dt>
<dd><p>System registers exported through crash notes.</p>
<p>The kexec / kdump code will create one XEN_ELFNOTE_CRASH_REGS note per cpu in case of a system crash. This note is architecture specific and will contain registers not saved in the “CORE” note. See xen/include/xen/elfcore.h for more information. </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_DUMPCORE_NONE">
<span class="target" id="group__elf__notes_1gaeffa39b16f217bd21d984d8a1c8f1b69"></span><code class="descname">XEN_ELFNOTE_DUMPCORE_NONE</code> 0x2000000<a class="headerlink" href="#c.XEN_ELFNOTE_DUMPCORE_NONE" title="Permalink to this definition">¶</a></dt>
<dd><p>xen dump-core none note. xm dump-core code will create one XEN_ELFNOTE_DUMPCORE_NONE in its dump file to indicate that the file is xen dump-core file. This note doesn’t have any other information. See tools/libxc/xc_core.h for more information. </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_DUMPCORE_HEADER">
<span class="target" id="group__elf__notes_1gacdb9817f0b1a3c670942395441c21242"></span><code class="descname">XEN_ELFNOTE_DUMPCORE_HEADER</code> 0x2000001<a class="headerlink" href="#c.XEN_ELFNOTE_DUMPCORE_HEADER" title="Permalink to this definition">¶</a></dt>
<dd><p>xen dump-core header note. xm dump-core code will create one XEN_ELFNOTE_DUMPCORE_HEADER in its dump file. See tools/libxc/xc_core.h for more information. </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_DUMPCORE_XEN_VERSION">
<span class="target" id="group__elf__notes_1ga63f3bdae3fe39f6aba31923788b8021c"></span><code class="descname">XEN_ELFNOTE_DUMPCORE_XEN_VERSION</code> 0x2000002<a class="headerlink" href="#c.XEN_ELFNOTE_DUMPCORE_XEN_VERSION" title="Permalink to this definition">¶</a></dt>
<dd><p>xen dump-core xen version note. xm dump-core code will create one XEN_ELFNOTE_DUMPCORE_XEN_VERSION in its dump file. It contains the xen version obtained via the XENVER hypercall. See tools/libxc/xc_core.h for more information. </p>
</dd></dl>

<dl class="define">
<dt id="c.XEN_ELFNOTE_DUMPCORE_FORMAT_VERSION">
<span class="target" id="group__elf__notes_1ga0bcde26302239523a6aeb9dc26c42a39"></span><code class="descname">XEN_ELFNOTE_DUMPCORE_FORMAT_VERSION</code> 0x2000003<a class="headerlink" href="#c.XEN_ELFNOTE_DUMPCORE_FORMAT_VERSION" title="Permalink to this definition">¶</a></dt>
<dd><p>xen dump-core format version note. xm dump-core code will create one XEN_ELFNOTE_DUMPCORE_FORMAT_VERSION in its dump file. It contains a format version identifier. See tools/libxc/xc_core.h for more information. </p>
</dd></dl>

</div>
</dd></dl>

</div>


           </div>
           <div class="articleComments">
            
           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="../../glossary.html" class="btn btn-neutral float-right" title="Glossary" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="xen_elfnote_features.html" class="btn btn-neutral" title="XEN ELFNOTE FEATURES" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, The Xen development community.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../',
            VERSION:'4.16-unstable',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true,
            SOURCELINK_SUFFIX: '.txt'
        };
    </script>
      <script type="text/javascript" src="../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../_static/doctools.js"></script>

  

  
  
    <script type="text/javascript" src="../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>